Subject: Re: "git pull . <branch>" versus "git merge <branch>"

From: Paolo Bonzini <[email-masked]>
Date: Tue, 10 Jun 2008 19:04:33 -0700

Miklos Vajna wrote:
> On Wed, Jun 11, 2008 at 03:13:45AM +0200, Rene Herman <[email-masked]> wrote:
>> So in the case of merging a branch from the local repository into the 
>> current branch, there is no difference between the two?
> 
> There is no difference, but you really want to use git merge and not git
> pull in such a case, I guess the git pull form is supported mainly to
> keep backwards compatibility.

However, when you're on a tracking merge only "git pull" will merge the 
right branch automatically into the current branch, fetching the branch 
name to merge from the config.  If the branch.*.remote config key is 
".", it will do a local merge.

Note that "git pull ." is optimized in that the fetch does nothing 
except setting up MERGE_HEAD.

Paolo